From 777ec3890722dbb22a4ad6fde0f8c1b0a9fd680b Mon Sep 17 00:00:00 2001
From: Wei Gao <gaowei66@huawei.com>
Date: Wed, 9 Dec 2020 03:57:43 -0500
Subject: [PATCH] qmp: fix a bug leads to high memory usage.

1. break the loop when `recvmsg` return 0.

Signed-off-by: Wei Gao <gaowei66@huawei.com>
---
 machine_manager/src/socket.rs | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git a/machine_manager/src/socket.rs b/machine_manager/src/socket.rs
index bb3bee3..ed20ff8 100644
--- a/machine_manager/src/socket.rs
+++ b/machine_manager/src/socket.rs
@@ -381,7 +381,7 @@ impl SocketRWHandler {
             MSG_DONTWAIT, SCM_RIGHTS, SOL_SOCKET,
         };
 
-        'read: loop {
+        loop {
             let tmp_buf = [0_u8; 1];
             let mut iov = iovec {
                 iov_base: tmp_buf.as_ptr() as *mut c_void,
@@ -418,10 +418,12 @@ impl SocketRWHandler {
             if ret == -1 {
                 let sock_err = io::Error::last_os_error();
                 if sock_err.kind() == io::ErrorKind::WouldBlock {
-                    break 'read;
+                    break;
                 } else {
                     return Err(sock_err);
                 }
+            } else if ret == 0 {
+                break;
             }
 
             let cmsg_hdr: Option<&cmsghdr> = unsafe {
-- 
2.27.0

